import random, sys, webbrowser
from PyQt6.QtCore import *
from PyQt6.QtGui import *
from PyQt6.QtWidgets import *

class KakeHissanPyQt(QMainWindow):
  def __init__(self):
    super().__init__()
    self.setWindowTitle(self.__class__.__name__)
    self.setGeometry(100, 100, 100, 400)

    menu = self.menuBar()
    menuFile = menu.addMenu('ファイル(&F)')
    menuFileExit = QAction(
      QIcon(self.style().standardIcon(
      QStyle.StandardPixmap.
      SP_TitleBarCloseButton)),
      '終了(&X)', menuFile)
    menuFileExit.triggered.connect(quit)
    menuFile.addAction(menuFileExit)
    menuHelp = menu.addMenu('ヘルプ(&H)')
    menuHelpWeb = QAction(
      QIcon(self.style().standardIcon(
      QStyle.StandardPixmap.
      SP_DialogHelpButton)),
      'Webサイトを開く(&W)', menuHelp)
    menuHelpWeb.triggered.connect(
      self.menuHelpWebClicked)
    menuHelp.addAction(menuHelpWeb)
    menuHelp.addSeparator()
    menuHelpVersion = QAction(
      QIcon(self.style().standardIcon(
      QStyle.StandardPixmap.
      SP_MessageBoxInformation)),
      'バージョン情報(&V)', menuHelp)
    menuHelpVersion.triggered.connect(
      self.menuHelpVersionClicked)
    menuHelp.addAction(menuHelpVersion)
    center = QWidget(self)
    center.layout = QGridLayout(center)
    center.setLayout(center.layout)
    self.setCentralWidget(center)

    label1 = QLabel('1行目桁数', center)
    label1.setAlignment(Qt.AlignmentFlag.AlignLeft
      | Qt.AlignmentFlag.AlignVCenter)
    center.layout.addWidget(label1, 0, 0)
    self.cb1 = QComboBox(center)
    self.cb1.addItems(['2', '3', '4', '5'])
    center.layout.addWidget(self.cb1, 0, 1)
    label2 = QLabel('2行目桁数', center)
    label2.setAlignment(Qt.AlignmentFlag.AlignRight
      | Qt.AlignmentFlag.AlignVCenter)
    center.layout.addWidget(label2, 0, 2)
    self.cb2 = QComboBox(center)
    self.cb2.addItems(['2', '3', '4', '5'])
    center.layout.addWidget(self.cb2, 0, 3)
    buttonQuestion = QPushButton('出題', center)
    buttonQuestion.clicked.connect(
      self.buttonQuestionClicked)
    center.layout.addWidget(buttonQuestion, 0, 4)
    self.buttonAnswer = QPushButton('答え', center)
    self.buttonAnswer.clicked.connect(
      self.buttonAnswerClicked)
    self.buttonAnswer.setEnabled(False)
    center.layout.addWidget(self.buttonAnswer, 0, 5)
    self.text = QTextEdit(center)
    self.text.setFont(QFont('ＭＳ 明朝', 32))
    self.text.setReadOnly(True)
    center.layout.addWidget(self.text, 1, 0, 1, 6)
    self.show()

  def menuHelpWebClicked(self):
    webbrowser.open(
      'https://info.nikkeibp.co.jp/media/NSW/')

  def menuHelpVersionClicked(self):
    s = self.__class__.__name__
    s += ' Version 0.01(2021/08/25)\n'
    s += 'c2021 Hideo Harada\n'
    s += 'with Python ' + sys.version
    QMessageBox.information(
      self, self.__class__.__name__, s)

  def buttonQuestionClicked(self):
    width1 = int(str(self.cb1.currentText()))
    self.width2 = int(str(self.cb2.currentText()))
    self.question1 = random.randrange(
      10**(width1-1), 10**width1-1)
    self.question2 = random.randrange(
      10**(self.width2-1), 10**self.width2-1)
    self.question = '{:>12}\n'.format(self.question1) + \
      '     ×{:>5}\n -------------\n'.format(self.question2)
    self.text.setText(self.question)
    self.buttonAnswer.setEnabled(True)

  def buttonAnswerClicked(self):
    answerString = self.question
    for i in range(1, self.width2+1):
      partialAnswer = self.question1 * \
        int(str(self.question2)[-i])
      if(partialAnswer != 0):
        answerString += ('{:>' + str(13-i) + '}\n'
          ).format(partialAnswer)
    answerString += ' -------------\n' + '{:>12}'.format(
      self.question1 * self.question2)
    self.text.setText(answerString)

app = QApplication([])
w = KakeHissanPyQt()
app.exec()
